import es,popuplib,services

info = es.AddonInfo()
info.name			= 'Botmenu'
info.version		= '1.2'
info.author			= 'Fault aka Immortal, Steam - Faultx'
info.basename		= 'botmenu'
info.description	= 'Write !bm in chat or bm in console and the BotMenu will open, spawn, kick, kill, set settings, set weapon restrictions for bots, with a simple menu'

auth = services.use('auth')
auth.registerCapability('botmenu', auth.ADMIN)

def load():
	es.set('bm_version',info.version)
	es.makepublic('bm_version')
	es.regsaycmd('!bm', 'botmenu/regcmd', 'Opens BotMenu')
	es.regclientcmd('bm', 'botmenu/regcmd', 'Opens BotMenu')

def regcmd():
	global useridx
	useridx = es.getcmduserid()
	if auth.isUseridAuthorized(useridx, 'botmenu'):
		botmain()
	else:
		es.tell(useridx, '#multi', '#greenYou are not authorized to use this command!')

def botmain():
	botmain = popuplib.create('BotMain')
	botmain.addline('BotMenu: Main Menu')
	botmain.addline('->1. Add Bots')
	botmain.addline('->2. Bot Weapon Restrictions')
	botmain.addline('->3. Bot Settings')
	botmain.addline('->4. Kill Bots')
	botmain.addline('->5. Kick Bots')
	botmain.addline(' ')
	botmain.addline('0. Close')
	botmain.menuselect = main_choice
	popuplib.send('BotMain', useridx)

def botadd():
	botadd = popuplib.create('BotAdd')
	botadd.addline('BotMenu: Add Bots')
	botadd.addline('->1. Add Bot')
	botadd.addline('->2. Bots Join Team: ' + es.server_var['bot_join_team'])
	botadd.addline(' ')
	botadd.addline('->8. Back')
	botadd.menuselect = add_choice
	popuplib.send('BotAdd', useridx)
	
def botres1():
	botres1 = popuplib.create('BotRes1')
	botres1.addline('BotMenu: Bot Weapon Restrictions 1/2')
	botres1.addline('1 means true and 0 means false')
	botres1.addline('->1. Allow Pistols: ' + es.server_var['bot_allow_pistols'])
	botres1.addline('->2. Allow Sub Machines: ' + es.server_var['bot_allow_sub_machine_guns'])
	botres1.addline('->3. Allow Shotguns: ' + es.server_var['bot_allow_shotguns'])
	botres1.addline('->4. Allow Machine Guns: ' + es.server_var['bot_allow_machine_guns'])
	botres1.addline('->5. Allow Rifles: ' + es.server_var['bot_allow_rifles'])
	botres1.addline('->6. Allow Snipers: ' + es.server_var['bot_allow_snipers'])
	botres1.addline('->7. Allow Grenades: ' + es.server_var['bot_allow_grenades'])
	botres1.addline(' ')
	botres1.addline('->8. Back')
	botres1.addline('->9. Next')
	botres1.menuselect = res1_choice
	popuplib.send('BotRes1', useridx)

def botres2():
	botres2 = popuplib.create('BotRes2')
	botres2.addline('BotMenu: Bot Weapon Restrictions 2/2')
	botres2.addline('->1. Allow All Weapons')
	botres2.addline('->2. Knives Only')
	botres2.addline('->3. Pistols Only')
	botres2.addline('->4. Snipers Only')
	botres2.addline(' ')
	botres2.addline('->8. Back')
	botres2.addline('->9. Main Menu')
	botres2.menuselect = res2_choice
	popuplib.send('BotRes2', useridx)

def botset1():
	botdif = ''
	if es.server_var['bot_difficulty'] == 0:
		botdif = 'easy'
	elif es.server_var['bot_difficulty'] == 1:
		botdif = 'normal'
	elif es.server_var['bot_difficulty'] == 2:
		botdif = 'hard'
	elif es.server_var['bot_difficulty'] == 3:
		botdif = 'expert'
	else:
		botdif = 'ERROR'
	botset1 = popuplib.create('BotSet1')
	botset1.addline('BotMenu: Bot Settings 1/2')
	botset1.addline('->1. Bot Quota (0-15): ' + es.server_var['bot_quota'])
	botset1.addline('->2. Bot Quota Mode: ' + es.server_var['bot_quota_mode'])
	botset1.addline('->3. Bot Difficulty: ' + botdif)
	botset1.addline('->4. Bot Chatter: ' + es.server_var['bot_chatter'])
	botset1.addline('->5. Bot Auto Follow: ' + es.server_var['bot_auto_follow'])
	botset1.addline('->6. Bot Auto Vacate: ' + es.server_var['bot_auto_vacate'])
	botset1.addline('->7. Bot Join After Player: ' + es.server_var['bot_join_after_player'])
	botset1.addline(' ')
	botset1.addline('->8. Back')
	botset1.addline('->9. Next')
	botset1.menuselect = set1_choice
	popuplib.send('BotSet1', useridx)

def botset2():
	botset2 = popuplib.create('BotSet2')
	botset2.addline('BotMenu: Bot Settings 2/2')
	botset2.addline('->1. Bot Defer To Human: ' + es.server_var['bot_defer_to_human'])
	botset2.addline('->2. Bot Allow Rogues: ' + es.server_var['bot_allow_rogues'])
	botset2.addline('->3. Bot Walk Only: ' + es.server_var['bot_walk'])
	botset2.addline('->4. Bot Eco Limit: ' + es.server_var['bot_eco_limit'])
	botset2.addline(' ')
	botset2.addline('->8. Back')
	botset2.addline('->9. Main Menu')
	botset2.menuselect = set2_choice
	popuplib.send('BotSet2', useridx)
	
def main_choice(userid, choice, popupid):
	if choice == 1:
		botadd()
	elif choice == 2:
		botres1()
	elif choice == 3:
		botset1()
	elif choice == 4:
		es.server.cmd('bot_kill')
		botmain()
	elif choice == 5:
		es.server.cmd('bot_kick')
		botmain()

def add_choice(userid, choice, popupid):
	if choice == 1:
		es.server.cmd('bot_add')
		botadd()
	elif choice == 2:
		if es.server_var['bot_join_team'] == 'any':
			es.server_var['bot_join_team'] = 't'
			botadd()
		elif es.server_var['bot_join_team'] == 't':
			es.server_var['bot_join_team'] = 'ct'
			botadd()
		else:
			es.server_var['bot_join_team'] = 'any'
			botadd()
	elif choice == 8:
		botmain()
		
def res1_choice(userid, choice, popupid):
	if choice == 1:
		if es.server_var['bot_allow_pistols'] == 0:
			es.server_var['bot_allow_pistols'] = 1
			botres1()
		else:
			es.server_var['bot_allow_pistols'] = 0
			botres1()
	elif choice == 2:
		if es.server_var['bot_allow_sub_machine_guns'] == 0:
			es.server_var['bot_allow_sub_machine_guns'] = 1
			botres1()
		else:
			es.server_var['bot_allow_sub_machine_guns'] = 0
			botres1()
	elif choice == 3:
		if es.server_var['bot_allow_shotguns'] == 0:
			es.server_var['bot_allow_shotguns'] = 1
			botres1()
		else:
			es.server_var['bot_allow_shotguns'] = 0
			botres1()
	elif choice == 4:
		if es.server_var['bot_allow_machine_guns'] == 0:
			es.server_var['bot_allow_machine_guns'] = 1
			botres1()
		else:
			es.server_var['bot_allow_machine_guns'] = 0
			botres1()
	elif choice == 5:
		if es.server_var['bot_allow_rifles'] == 0:
			es.server_var['bot_allow_rifles'] = 1
			botres1()
		else:
			es.server_var['bot_allow_rifles'] = 0
			botres1()
	elif choice == 6:
		if es.server_var['bot_allow_snipers'] == 0:
			es.server_var['bot_allow_snipers'] = 1
			botres1()
		else:
			es.server_var['bot_allow_snipers'] = 0
			botres1()
	elif choice == 7:
		if es.server_var['bot_allow_grenades'] == 0:
			es.server_var['bot_allow_grenades'] = 1
			botres1()
		else:
			es.server_var['bot_allow_grenades'] = 0
			botres1()
	elif choice == 8:
		botmain()
	elif choice == 9:
		botres2()

def res2_choice(userid, choice, popupid):
	if choice == 1:
			es.server.cmd('bot_all_weapons')
			botres2()
	elif choice == 2:
			es.server.cmd('bot_knives_only')
			botres2()
	elif choice == 3:
			es.server.cmd('bot_pistols_only')
			botres2()
	elif choice == 4:
			es.server.cmd('bot_snipers_only')
			botres2()
	elif choice == 8:
		botres1()
	elif choice == 9:
		botmain()

def set1_choice(userid, choice, popupid):
	if choice == 1:
		if es.server_var['bot_quota'] < 15:
			es.server_var['bot_quota'] = es.server_var['bot_quota'] + 1
			botset1()
		else:
			es.server_var['bot_quota'] = 0
			botset1()
	elif choice == 2:
		if es.server_var['bot_quota_mode'] == 'fill':
			es.server_var['bot_quota_mode'] = 'normal'
			botset1()
		else:
			es.server_var['bot_quota_mode'] = 'fill'
			botset1()
	elif choice == 3:
		if es.server_var['bot_difficulty'] < 3:
			es.server_var['bot_difficulty'] = es.server_var['bot_difficulty'] + 1
			botset1()
		else:
			es.server_var['bot_difficulty'] = 0
			botset1()
	elif choice == 4:
		if es.server_var['bot_chatter'] == 'normal':
			es.server_var['bot_chatter'] = 'radio'
			botset1()
		elif es.server_var['bot_chatter'] == 'radio':
			es.server_var['bot_chatter'] = 'minimal'
			botset1()
		elif es.server_var['bot_chatter'] == 'minimal':
			es.server_var['bot_chatter'] = 'off'
			botset1()
		else:
			es.server_var['bot_chatter'] = 'normal'
			botset1()
	elif choice == 5:
		if es.server_var['bot_auto_follow'] == 0:
			es.server_var['bot_auto_follow'] = 1
			botset1()
		else:
			es.server_var['bot_auto_follow'] = 0
			botset1()
	elif choice == 6:
		if es.server_var['bot_auto_vacate'] == 0:
			es.server_var['bot_auto_vacate'] = 1
			botset1()
		else:
			es.server_var['bot_auto_vacate'] = 0
			botset1()
	elif choice == 7:
		if es.server_var['bot_join_after_player'] == 0:
			es.server_var['bot_join_after_player'] = 1
			botset1()
		else:
			es.server_var['bot_join_after_player'] = 0
			botset1()
	elif choice == 8:
		botmain()
	elif choice == 9:
		botset2()

def set2_choice(userid, choice, popupid):
	if choice == 1:
		if es.server_var['bot_defer_to_human'] == 0:
			es.server_var['bot_defer_to_human'] = 1
			botset2()
		else:
			es.server_var['bot_defer_to_human'] = 0
			botset2()
	elif choice == 2:
		if es.server_var['bot_allow_rogues'] == 0:
			es.server_var['bot_allow_rogues'] = 1
			botset2()
		else:
			es.server_var['bot_allow_rogues'] = 0
			botset2()
	elif choice == 3:
		if es.server_var['bot_walk'] == 0:
			es.server_var['bot_walk'] = 1
			botset2()
		else:
			es.server_var['bot_walk'] = 0
			botset2()
	elif choice == 4:
		if es.server_var['bot_eco_limit'] < 16000:
			es.server_var['bot_eco_limit'] = es.server_var['bot_eco_limit'] + 500
			botset2()
		else:
			es.server_var['bot_eco_limit'] = 0
			botset2()
	elif choice == 8:
		botset1()
	elif choice == 9:
		botmain()
		
def unload():
	popuplib.delete('BotMain')
	popuplib.delete('BotAdd') 
	popuplib.delete('BotRes1')
	popuplib.delete('BotRes2')
	popuplib.delete('BotSet1')
	popuplib.delete('BotSet2')
	es.unregsaycmd('!bm')
	es.unregclientcmd('bm')